package com.app.mysample;

import java.util.List;

import javax.enterprise.context.RequestScoped;
import javax.enterprise.inject.Produces;
import javax.inject.Inject;
import javax.inject.Named;
import javax.persistence.EntityManager;


@Named("helloBean")
@RequestScoped
public class HelloBean {

	private Person person = new Person();
	private List<Person> people;

	@DataRepository
	@Inject
	private EntityManager entityManager;
	
	public String getMessage() {
		return "Hello from Java EE Application on Heroku !";
	}

	public void savePerson() {
		entityManager.getTransaction().begin();		
		entityManager.persist(person);
		entityManager.getTransaction().commit();
		person = new Person();
		people = null;
	}

	public Person getPerson() {
		return person;
	}
	
	@Produces @Named
    @SuppressWarnings("unchecked")
	public List<Person> getPeople() {
		if (people == null) {
			people = entityManager.createQuery("select p from Person p")
					.getResultList();
		}
		return people;
	}	
}
